import { BulkUpdateService } from "../types/bulk-update-service-type";
import { DeleteService } from "../types/delete-service-type";
import { CreateService } from "../types/create-service-type";
import { ListService } from "../types/list-service-type";
import { GetService } from "../types/get-service-type";
import { NestedCreateService } from "../types/nested-create-service-type";
import { NestedListService } from "../types/nested-list-service-type";
import { UpdateService } from "../types/update-service-type";
declare const ServiceFactory: {
    bulkUpdate<TRecord extends any, TPathParams extends any>(recordType: new () => TRecord, resourceEndpoint: string): BulkUpdateService<TRecord, TPathParams>;
    create<TRecord_1 extends any>(recordType: new () => TRecord_1, baseEndpoint: string): CreateService<TRecord_1>;
    delete(resourceEndpoint: string): DeleteService;
    get<TRecord_2, TPathParams_1, TQueryParams = undefined>(recordType: new () => TRecord_2, resourceEndpoint: string): GetService<TRecord_2, TPathParams_1, TQueryParams>;
    list<TRecord_3, TQueryParams_1>(recordType: new () => TRecord_3, baseEndpoint: string): ListService<TRecord_3, TQueryParams_1>;
    nestedCreate<TRecord_4 extends any, TPathParams_2>(recordType: new () => TRecord_4, baseEndpoint: string): NestedCreateService<TRecord_4, TPathParams_2>;
    nestedList<TRecord_5, TPathParams_3, TQueryParams_2>(recordType: new () => TRecord_5, baseEndpoint: string): NestedListService<TRecord_5, TPathParams_3, TQueryParams_2>;
    update<TRecord_6 extends any, TPathParams_4 extends any>(recordType: new () => TRecord_6, resourceEndpoint: string): UpdateService<TRecord_6, TPathParams_4>;
};
export { ServiceFactory };
